﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;
using System.Data.SqlClient;

namespace DA
{
    public static class CompanyDataAdapter
    {
        static string connectionString = DA.Settings.Default.connectionString;

        static public int RegisterCompany(int userId , string name, string regCmpId, string country,
            string category, string website, string email, DateTime crdate,string companyLogo,string state,string address)
        {
            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = connection.CreateCommand();
            command.CommandType = System.Data.CommandType.Text;

            command.CommandText = "Insert into Company (name, company_reg_id, country, category, " +
            "web_site, email,creation_date,user_id,logo,state,address) values(@name, @company_reg_id, @country, @category, @web_site, @email,@crdate,@userId,@companyLogo,@state,@address);" +
            "Select SCOPE_IDENTITY()";

            command.Parameters.AddWithValue("@name", name);
            command.Parameters.AddWithValue("@company_reg_id", regCmpId);
            command.Parameters.AddWithValue("@country", country);
            command.Parameters.AddWithValue("@category", category);
            command.Parameters.AddWithValue("@web_site", website);
            command.Parameters.AddWithValue("@email", email);
            command.Parameters.AddWithValue("@crdate", crdate);
            command.Parameters.AddWithValue("@companyLogo", companyLogo);
            command.Parameters.AddWithValue("@userId", userId);
            command.Parameters.AddWithValue("@state", state);
            command.Parameters.AddWithValue("@address", address);

            int companyId = 0;
            try
            {
                connection.Open();
                companyId = int.Parse(command.ExecuteScalar().ToString());

            }
            finally
            {
                connection.Close();
            }

            addCompanyUser(userId, companyId);

            return companyId;
        }

        static public string[] FindCompany(int companyId)
        {
            string[] company = new string[10];

            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = connection.CreateCommand();
            command.CommandType = System.Data.CommandType.Text;
            command.CommandText = "Select * from company where id=@companyId";
            command.Parameters.AddWithValue("@companyId", companyId);

            try
            {
                connection.Open();
                SqlDataReader reader = command.ExecuteReader();
                while (reader.Read())
                {
                    company = new string[] { reader["id"].ToString(),
                        reader["company_reg_id"].ToString(),
                        reader["name"].ToString(),
                        reader["category"].ToString(),
                        reader["country"].ToString(),
                        reader["web_site"].ToString(),
                        reader["email"].ToString(),
                        reader["longitude"].ToString(),
                        reader["latitude"].ToString()};
                }
            }
            finally
            {
                connection.Close();
            }
            return company;
        }

        static public string[] FindCompanyByName(string companyName)
        {
            string[] company = new string[10];

            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = connection.CreateCommand();
            command.CommandType = System.Data.CommandType.Text;
            command.CommandText = "Select * from company where name=%@companyId%";
            command.Parameters.AddWithValue("@companyName", companyName);

            try
            {
                connection.Open();
                SqlDataReader reader = command.ExecuteReader();
                while (reader.Read())
                {
                    company = new string[] { reader["id"].ToString(),
                        reader["company_reg_id"].ToString(),
                        reader["name"].ToString(),
                        reader["category"].ToString(),
                        reader["country"].ToString(),
                        reader["web_site"].ToString(),
                        reader["email"].ToString()};
                }
            }
            finally
            {
                connection.Close();
            }
            return company;
        }

        static public int addCompanyUser(int userId, int companyId)
        {
            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = connection.CreateCommand();
            command.CommandType = System.Data.CommandType.Text;
            command.CommandText = "Insert into company_user (companyId, userId) values(@companyId, @userId)";
            command.Parameters.AddWithValue("@companyId", companyId);
            command.Parameters.AddWithValue("@userId", userId);
            try
            {
                connection.Open();

                // add to company_user table

                command.ExecuteNonQuery();

            }
            finally
            {
                connection.Close();
            }
            return companyId;
        }
        static public string[] GetCompanyInfoById(int companyId)
        {
            string[] companyInfo;
            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = connection.CreateCommand();
            command.CommandType = System.Data.CommandType.Text;
            command.CommandText = "Select name, logo from company where id=@companyId";
            command.Parameters.AddWithValue("@companyId", companyId);
            try
            {
                connection.Open();
                SqlDataReader reader = command.ExecuteReader();
                reader.Read();
                companyInfo = new string[] { reader[0].ToString(), reader[1].ToString() };
            }
            finally
            {
                connection.Close();
            }
            return companyInfo;
        }
        static public List<string[]> GetCompaniesInfoForMap()
        {
            List<string[]> companiesInfo= new List<string[]>();
            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = connection.CreateCommand();
            command.CommandType = System.Data.CommandType.Text;
            command.CommandText = "Select name, web_site, longitude, latitude from company";
            try
            {
                connection.Open();
                SqlDataReader reader = command.ExecuteReader();
                while (reader.Read())
                {
                    companiesInfo.Add(new string[] { reader[0].ToString(), reader[1].ToString(), reader[2].ToString(), reader[3].ToString() });
                }
            }
            finally
            {
                connection.Close();
            }
            return companiesInfo;
        }
        static public List<string[]> SearchForCompaniesInfoForMap(string compName)
        {
            List<string[]> companiesInfo = new List<string[]>();
            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = connection.CreateCommand();
            command.CommandType = System.Data.CommandType.Text;
            command.Parameters.AddWithValue("@compName", compName);

            command.CommandText = "Select name, web_site, longitude, latitude from company where name like '%'+@compName+'%'";
            try
            {
                connection.Open();
                SqlDataReader reader = command.ExecuteReader();
                while (reader.Read())
                {
                    companiesInfo.Add(new string[] { reader[0].ToString(), reader[1].ToString(), reader[2].ToString(), reader[3].ToString() });
                }
            }
            finally
            {
                connection.Close();
            }
            return companiesInfo;
        }
    }
}
