﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;
using System.Data.SqlClient;

namespace DA
{
    public static class ProjectDataAdapter
    {
        static string connectionString = DA.Settings.Default.connectionString;

        static public int RegisterProject(int companyId, string compname, string state, string title,string clientName,
            string description,DateTime start_date,DateTime end_date,string Projimage)
        {
            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = connection.CreateCommand();
            command.CommandType = System.Data.CommandType.Text;

            command.CommandText = "Insert into projects (comp_id, name, description,start_date,end_date,ongoing,clientName,image) values(@compId,@name,@description,@startDate,@endDate, @ongoing, @clientName, @image);" +
            "Select SCOPE_IDENTITY()";

            command.Parameters.AddWithValue("@compId", companyId);
            command.Parameters.AddWithValue("@name", title);
            command.Parameters.AddWithValue("@description", description);
            command.Parameters.AddWithValue("@startDate", start_date);
            command.Parameters.AddWithValue("@endDate", end_date);

            if(state == "Open")
            {
                command.Parameters.AddWithValue("@ongoing", true);
            }
            else
            {
                command.Parameters.AddWithValue("@ongoing", false);
            }
            command.Parameters.AddWithValue("@image", Projimage);
            command.Parameters.AddWithValue("@clientName", clientName);

            int projectId = 0;
            try
            {
                connection.Open();
                projectId = int.Parse(command.ExecuteScalar().ToString());

            }
            finally
            {
                connection.Close();
            }

            addCompanyProject(projectId, companyId);

            return projectId;
        }


        static public int addCompanyProject(int projectId, int companyId)
        {
            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = connection.CreateCommand();
            command.CommandType = System.Data.CommandType.Text;
            command.CommandText = "Insert into project_company (company_Id, project_Id) values(@companyId, @projectId)";
            command.Parameters.AddWithValue("@companyId", companyId);
            command.Parameters.AddWithValue("@projectId", projectId);
            try
            {
                connection.Open();

                // add to company_user table

                command.ExecuteNonQuery();

            }
            finally
            {
                connection.Close();
            }
            return (companyId);
        }
    }
}
