﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using DA;

public partial class MessagesPage : System.Web.UI.Page
{
    public string Messages
    {
        get { return messages; }
    }
    string messages = "<div style='width:600px;'>";

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!User.Identity.IsAuthenticated)
        {
            notLoggedIn.Visible = true;
            loggedIn.Visible = false;
            return;
        }
        notLoggedIn.Visible = false;
        loggedIn.Visible = true;

        List<string[]> msgs;
        if (Request.QueryString["type"] == "out")
        {
            msgs = MessagesDataAdapter.GetOutgoingMessagesByUserId(int.Parse(User.Identity.Name));
            OutLink.CssClass = "navLink slctd";
        }
        else
        {
            msgs = MessagesDataAdapter.GetIncomingMessagesByUserId(int.Parse(User.Identity.Name));
            InLink.CssClass = "navLink slctd";
        }
        
        foreach (string[] message in msgs)
        {
            int userId = (Request.QueryString["type"] == "out") ? int.Parse(message[2]) : int.Parse(message[1]);
            string[] userInfo = UserDataAdapter.GetUserInfoById(userId);
            string color = (message[6] == "False") ? "rgb(255,245,238)" : "rgba(239, 247, 252, 0.589844)";
            
            messages +=
            "<div id=\"msg_" + message[0] + "\" style=\"background-color: " + color + ";border-radius: 6px 6px; clear:both; padding:5px; margin:5px 0px; display:block; -webkit-transition: background-color 0.5s linear;\">" +
                "<a href=\"UserProfile.aspx?id=" + userId + "\">" +
                    "<img style=\"float:left; border-radius: 6px 6px; height:64px; width:64px;\" src=\"UserAvatars/" + userInfo[2] + "\"/>" +
                "</a>" +
                "<span style=\"margin-left:10px; float:left;\" class=\"goodLookingCommentAuthor\">" +
                    "<a href=\"UserProfile.aspx?id=" + userId + "\" style=\"color: #1A74B0;\" class=\"msgsLink\">" +
                        userInfo[0] + " " + userInfo[1] +
                    "</a>" +
                "</span>" +
                "<span style=\"margin-left:10px; float:left;\" class=\"goodLookingCommentDate\">" +
                     message[5] +
                "</span>" +
                "<a href=\"NewMessagePage.aspx?id=" + userId + "\" style=\"float:right;\" class=\"msgsLink\" >" + (Request.QueryString["type"] == "out" ? "One more" : "Reply") + "</a><br />" +
                "<div style=\"padding: 0px 0px 0px 78px; margin-right:50px;\">" +
                    "<span  style=\"margin-top:10px; \">" +
                        "<a href=\"Message.aspx?id=" + message[0] + "\" class=\"subject_text\">" + message[3] + "</a><br /><br />" +
                        "<a onclick=\"showMessageInPopup(" + userId + ",'" + "userFirstName" + "','" + "userLastName" + "','" + "userAvatarPath" + "','" + message[5] + "','" + message[3] + "','" + message[4] + "'," + message[0] + "," + "typeOfMessage" + "," + message[6] + ")\" class=\"snippet\">" + message[4] + "</a>" +
                    "<span>" +
                "</div>" +
                "<a onclick=\"deleteMessage(" + message[0] + "," + "typeOfMessage" + ")\" class=\"msgsLink\" style=\"float:right; margin-top:-25px; text-decoration:none;color:#2C8AC7;\">Delete</a>" +
                //"<div style=\"clear:both;\"></div>" +
            "</div>";
        }
        messages += "</div>";
    }
}